"""
gst-launch-1.0 pylonsrc device-index=0 cam::Gain=10.3 cam::ExposureTime=60000 \
    ! "video/x-raw,width=2448,height=2048,framerate=30/1,format=GRAY8" \
    ! videoconvert \
    ! nvvideoconvert \
    ! m.sink_0 nvstreammux name=m batch-size=1 width=2448 height=2048 \
    ! nvrtspoutsinkbin bitrate=4000000

gst-launch-1.0 pylonsrc device-index=0 cam::Gain=10.3 cam::ExposureTime=60000 \
    ! "video/x-raw,width=2448,height=2048,framerate=30/1,format=BGR" \
    ! videoconvert \
    ! nvvidconv \
    ! m.sink_0 nvstreammux name=m batch-size=1 width=2448 height=2048 \
    ! nvrtspoutsinkbin bitrate=4000000

gst-launch-1.0 pylonsrc device-index=0 cam::Gain=10.3 cam::ExposureTime=60000 ! "video/x-raw,width=1024,height=1024,framerate=5/1,format=GRAY8"  !  videoconvert ! nvvidconv  !  nvrtspoutsinkbin codec=h265

gst-launch-1.0 pylonsrc device-index=0 cam::AutoFunctionProfile=MinimizeGain ! "video/x-raw,width=1024,height=1024,framerate=5/1,format=GRAY8"  !  videoconvert ! nvvidconv  !  nvrtspoutsinkbin codec=h265

nvvidconv non è un plugin deepstream

"""

from mev_yolodeep.lib.pipeline import Pipeline


class SimplePipeline(Pipeline):
    def __init__(self, config=None):
        super().__init__(config=config)

    def setup(self):
        self.create_basler(index=0, serial=self.config.camera[0])
        self.create_basler(index=1, serial=self.config.camera[1])
        self.streammux = self.create_streammux(live=True)

        if self.config.rtsp:
            self.create_tiler()
            self.create_element("nvvideoconvert")
            self.create_rtsp_out()
        else:
            demux = self.create_streamdemux()

            def _out(source_id, pad):
                queue = self._element(
                    "queue"
                )  # risolve i blocchi saltuari della pipeline durante lo start

                if self.config.save_frames:
                    out = self.create_jpeg_out(source_id=source_id)
                elif self.config.save:
                    out = self.create_file_out(source_id=source_id)
                else:
                    out = self.create_fake(link=False)
                pad.link(queue.get_static_pad("sink"))
                queue.link(out)

            _out(source_id=0, pad=demux.get_request_pad("src_0"))
            _out(source_id=1, pad=demux.get_request_pad("src_1"))


def run(config):
    pipeline = SimplePipeline(config=config)
    pipeline.run()
