#  Copyright (C) 2020 Matteo Benedetto <me at enne2.net>
import gi

gi.require_version("Gst", "1.0")
gi.require_version("GstRtspServer", "1.0")
from gi.repository import GLib, Gst, GstRtspServer

Gst.init(None)

port = "8554"
mount_point = "/ds"

server = GstRtspServer.RTSPServer.new()
server.set_service(port)
server.set_address("0.0.0.0")
mounts = server.get_mount_points()
factory = GstRtspServer.RTSPMediaFactory.new()
factory.set_launch(
    "videotestsrc ! videoconvert ! theoraenc ! queue ! rtptheorapay name=pay0"
)
mounts.add_factory(mount_point, factory)
server.attach()

#  start serving
print("stream ready at rtsp://0.0.0.0:" + port + mount_point)
loop = GLib.MainLoop()
loop.run()
